---
title: FileSystemFileEntry
slug: Web/API/FileSystemFileEntry
tags:
  - API
  - File API
  - File System API
  - File and Directory Entries API
  - FileEntry
  - Files
  - Interface
  - Offline
  - Reference
---
<div>{{APIRef("File System API")}}{{SeeCompatTable}}</div>

<p>The <strong><code>FileSystemFileEntry</code></strong> interface of the <a href="/en/DOM/File_API/File_System_API" title="en/DOM/File_API/File_System_API">File System API</a> represents a file in a file system. It offers properties describing the file's attributes, as well as the {{domxref("FileSystemFileEntry.file", "file()")}} method, which creates a {{domxref("File")}} object that can be used to read the file.</p>

<h2 id="Properties" style="line-height: 30px; font-size: 2.14285714285714rem;">Properties</h2>

<p><em>Inherits the properties of its parent interface, {{domxref("FileSystemEntry")}}, but has no properties unique to this interface.</em></p>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref("FileSystemFileEntry.file", "file()")}}</dt>
	<dd>Creates a new {{domxref("File")}} object which can be used to read the file.</dd>
</dl>

<h3 id="basic_concepts">Obsolete methods</h3>

<dl>
	<dt>{{domxref("FileSystemFileEntry.createWriter", "createWriter()")}} {{obsolete_inline}}</dt>
	<dd>Creates a new {{domxref("FileWriter")}} object which allows writing to the file represented by the file system entry.</dd>
</dl>

<h2 id="basic_concepts">Basic concepts</h2>

<p>To write content to file, create a {{domxref("FileWriter")}} object by calling {{domxref("FileSystemFileEntry.createWriter", "createWriter()")}}. To read a file, obtain a {{domxref("File")}} object representing its contents by calling {{domxref("FileSystemFileEntry.file", "file()")}}.</p>

<h3 id="example">Example</h3>

<p>The following code creates an empty file called "<code>log.txt"</code> (if it doesn't exist) and fills it with the text "Meow". Inside the success callback, event handlers are set up to handle the {{event("error")}} <code>error</code> and {{event("writeend")}} events. The text data is written to the file by creating a blob, appending text to it, and passing the blob to {{domxref("FileWriter.write()")}}.</p>

<pre class="brush: js">function onInitFs(fs) {
  fs.root.getFile('log.txt', {create: true}, function(fileEntry) {

    // Create a FileWriter object for our FileSystemFileEntry (log.txt).
    fileEntry.createWriter(function(fileWriter) {
      fileWriter.onwriteend = function(e) {
        console.log('Write completed.');
      };

      fileWriter.onerror = function(e) {
        console.log('Write failed: ' + e.toString());
      };

      // Create a new Blob and write it to log.txt.
      var bb = new BlobBuilder();
      bb.append('Meow');

      fileWriter.write(bb.getBlob('text/plain'));
    }, errorHandler);

  }, errorHandler);

}

window.requestFileSystem(window.TEMPORARY, 1024*1024, onInitFs, errorHandler);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<thead>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td>{{SpecName('File System API', '#api-fileentry', 'FileSystemFileEntry')}}</td>
			<td>{{Spec2('File System API')}}</td>
			<td>Draft of proposed API</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileSystemFileEntry")}}</p>

<h2 id="See_also">See also</h2>

<ul>
	<li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API">File and Directory Entries API</a></li>
	<li><a href="/en-US/docs/Web/API/File_and_Directory_Entries_API/Introduction">Introduction to the File System API</a></li>
</ul>
